import type { Validator } from './validateAtoms';
import { AtomWithValidation } from './validateAtoms';
type Options<Vkeys extends symbol | string | number, Vvals> = {
    validate: Validator<Vkeys, Vvals>;
};
export type ActionableNext = {
    action: 'SET_VALUE' | 'SET_FOCUSED' | 'SET_TOUCHED';
    key: string;
    value: any;
};
export declare function atomWithFormControls<AtomGroup extends Record<string, AtomWithValidation<any>>, Keys extends keyof AtomGroup, Vals extends AtomGroup[Keys]>(labeledAtoms: AtomGroup, options?: Options<Keys, Vals>): import("jotai/vanilla").Atom<(get: <Value>(atom: import("jotai/vanilla").Atom<Value>) => Value, atomOptions: {
    readonly signal: AbortSignal;
    readonly setSelf: <A extends unknown[]>(...args: A) => unknown;
}) => {
    isValid: boolean;
    fieldErrors: Record<Keys, any>;
    touched: Record<Keys, boolean>;
    focused: Record<Keys, boolean>;
    setValue(key: Keys, value: Vals): void;
    setTouched(key: Keys, val: boolean): void;
    setFocused(key: Keys, val: boolean): void;
    handleOnChange(key: Keys): (val: any) => void;
    handleOnFocus(key: Keys): () => unknown;
    handleOnBlur(key: Keys): () => void;
    values: Record<Keys, import("./validateAtoms").ExtractTypeOfValidatorValue<Vals>>;
    error: unknown;
    isValidating: boolean | undefined;
}>;
export {};
